## daqd-stream 0.6.0.x202512162308fe7047ff5b

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
project(daqd_stream)

# Set policies to suppress warnings about deprecated modules
if(POLICY CMP0148)
    cmake_policy(SET CMP0148 OLD)  # Allow FindPythonLibs/FindPythonInterp
endif()
if(POLICY CMP0167)
    cmake_policy(SET CMP0167 OLD)  # Allow FindBoost
endif()

set(CMAKE_CXX_STANDARD 14)
SET( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/config" )

set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE)

include(Integration)
include(GNUInstallDirs)

find_package(pybind11 REQUIRED)
find_package(CURL)
find_package(RapidJSON)
find_package(libcds-pubsub)

find_package(Python3 COMPONENTS Interpreter Development)

set (PYTHON_EXECUTABLE "${Python3_EXECUTABLE}")

find_package(Boost COMPONENTS system filesystem process)
find_package(Threads)
find_package(nds2-client)
find_package(FrameCPP)
find_package(advLigoRTS)

enable_testing()

#add_compile_options("-fsanitize=thread")
#add_link_options("-fsanitize=thread")
#add_compile_options("-fsanitize=address")
#add_link_options("-fsanitize=address")

add_subdirectory(external)
add_subdirectory(src)
add_subdirectory(support)
add_subdirectory(python)

# https://stackoverflow.com/questions/5378528/install-export-problem-for-shared-lib-with-dependencies
install( EXPORT daqd_stream_install
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/daqd_stream
        NAMESPACE daqd_stream::
        FILE daqd_streamConfig.cmake
        )

=== external/CMakeLists.txt ===
add_subdirectory(catch2)

=== python/CMakeLists.txt ===
add_subdirectory(client)
add_subdirectory(probe)

=== src/CMakeLists.txt ===
add_subdirectory(vendor)
add_subdirectory(common)
add_subdirectory(plugins)
add_subdirectory(client)
add_subdirectory(service)
add_subdirectory(probe_support)
add_subdirectory(apps)

=== support/CMakeLists.txt ===
#install(FILES daqd-stream-server.service
#        DESTINATION lib/systemd/system)
#install(FILES daqd-stream-server.defaults
#        DESTINATION etc/defaults
#        RENAME daqd-stream-server)

=== external/catch2/CMakeLists.txt ===
add_library(catch2 INTERFACE)
target_include_directories(catch2 INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})

=== python/client/CMakeLists.txt ===
file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/generated")

set(incl_root "${CMAKE_SOURCE_DIR}/src/client/include/daqd_stream")
add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/generated/daqd_stream_doc_strings.inc"
        COMMAND ${PYTHON_EXECUTABLE} -B ${CMAKE_SOURCE_DIR}/scrape_docs.py -g DOCS_DAQD_STREAM -i "${incl_root}/daqd_stream.hh" "${incl_root}/basic_types.hh" "${incl_root}/dcu_identifier.hh" "${incl_root}/fixed_string.hh" "${incl_root}/online_channel.hh" "${incl_root}/time_point.hh"  -o "${CMAKE_CURRENT_BINARY_DIR}/generated/daqd_stream_doc_strings.inc"
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        DEPENDS daqd_stream_client)

add_custom_target(generate_daqd_stream_doc_strings
        DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/generated/daqd_stream_doc_strings.inc")

pybind11_add_module(daqd_stream client.cc)
target_link_libraries(daqd_stream PRIVATE daqd_stream_client)
target_include_directories(daqd_stream PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/generated")
add_dependencies(daqd_stream
        generate_daqd_stream_doc_strings)

install(TARGETS daqd_stream DESTINATION "${Python3_SITEARCH}")

configure_file(tests/test_daqd_client.py ${CMAKE_CURRENT_BINARY_DIR}/test_daqd_client.py COPYONLY)

integration_test( NAME channel_list_changes
        SCRIPT tests/test_channel_list_changes.py)

integration_test( NAME server_custom_size
        SCRIPT tests/test_server_custom_size.py)


#add_test(NAME test_daqd_client_py
#        COMMAND ${PYTHON_EXECUTABLE} -B test_daqd_client.py
#        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

=== python/probe/CMakeLists.txt ===
pybind11_add_module(daqd_probe daqd_probe_py.cc)
target_link_libraries(daqd_probe PRIVATE probe_support)

=== src/apps/CMakeLists.txt ===


add_executable(test_daqd_stream_client
        client.cpp)
target_link_libraries(test_daqd_stream_client PUBLIC daqd_stream_client)

#install(EXPORT daqd_stream
#        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/daqd_stream
#        NAMESPACE daqd_stream::
#        FILE daqd_streamConfig.cmake
#        )

add_executable(sample_client sample_client.cc)
target_link_libraries(sample_client PUBLIC
        daqd_stream_client)

add_subdirectory(daqd_stream_cross_check)
add_subdirectory(daqd_stream_server)
add_subdirectory(daqd_stream_xmit)
add_subdirectory(daqd_stream_probe)

=== src/client/CMakeLists.txt ===
add_library(daqd_stream_core INTERFACE)
target_include_directories(daqd_stream_core INTERFACE
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

add_library(daqd_stream_client STATIC

        data_plan.cc
        daq_client.cc
        load_data.cc
        endian_utility.cc
        include/daqd_stream/daqd_stream.hh
        )
target_include_directories(daqd_stream_client PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/private)
target_include_directories(daqd_stream_client PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
target_include_directories(daqd_stream_client PRIVATE
        ${RAPIDJSON_INCLUDE_DIRS}
        )
target_link_libraries(daqd_stream_client PUBLIC
        daqd_stream_core
        Boost::boost
        Boost::system
        rt)
target_link_libraries(daqd_stream_client PRIVATE
        vendor
        daqd_stream_common
        )
target_compile_options(daqd_stream_client PRIVATE -fPIC)

install(TARGETS daqd_stream_client
        EXPORT daqd_stream_install
        DESTINATION lib)
install(TARGETS daqd_stream_core
        EXPORT daqd_stream_install)
install(FILES
        include/daqd_stream/basic_types.hh
        include/daqd_stream/daqd_stream.hh
        include/daqd_stream/dcu_identifier.hh
        include/daqd_stream/fixed_string.hh
        include/daqd_stream/online_channel.hh
        include/daqd_stream/time_point.hh
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/daqd_stream)

add_library(test_helpers STATIC
        tests/test_helpers.cc)
target_include_directories(test_helpers PUBLIC
        "${CMAKE_CURRENT_SOURCE_DIR}/tests")
target_link_libraries(test_helpers PUBLIC
        Threads::Threads)


add_executable(test_daqd_dcu_status_progressions tests/test_daqd_dcu_status_progressions.cc)
target_link_libraries(test_daqd_dcu_status_progressions PUBLIC
        daqd_stream_client)

add_executable(test_load tests/test_load.cc)
target_link_libraries(test_load PUBLIC
        daqd_stream_client
        Threads::Threads)

add_executable(daqd_stream_unit_tests
        tests/sample_channel_lists.cc
        tests/test_main.cc
        tests/test_dcu_identifier.cc
        tests/test_client_api.cc
        tests/test_internal.cc
        tests/test_avail_info.cc
        tests/test_multi_source_methods.cc
        tests/test_load_data.cc
        tests/test_endian_utilities.cc)
target_link_libraries(daqd_stream_unit_tests
        PRIVATE
        vendor
        daqd_stream_common
        daqd_stream_client
        catch2)
target_include_directories(daqd_stream_unit_tests
        PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/private)



add_executable( test_consuming_multi_streams
        tests/test_main.cc
        tests/test_consuming_multi_streams.cc
        tests/simple_data.cc)
target_include_directories( test_consuming_multi_streams PUBLIC
        "${CMAKE_CURRENT_SOURCE_DIR}/private")
target_link_libraries(test_consuming_multi_streams
        catch2
        vendor
        cds::pub_sub
        daqd_stream_client
        daqd_stream_plugins
        daqd_stream_common
        daqd_stream_server
        frame_utils
        test_helpers)

integration_test( NAME test_missing_data_is_0xbad
        SCRIPT tests/test_missing_data_is_0xbad.py )

integration_test( NAME test_reconfigured_data_is_0x2000
        SCRIPT tests/test_reconfigured_data_is_0x2000.py )

integration_test( NAME test_remove_then_readd_channel
        SCRIPT tests/test_remove_then_readd_channel.py )

integration_test( NAME test_multi_source_channel_listing
        SCRIPT tests/test_multi_source_channel_listing.py )



add_test(NAME test_consuming_multi_streams
        COMMAND test_consuming_multi_streams
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

add_test(NAME test_daqd_stream_unit_tests
        COMMAND daqd_stream_unit_tests
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

=== src/common/CMakeLists.txt ===
add_library(daqd_stream_common STATIC
        crc.c
        checksum.cc
        posix_shmem.cc)
target_link_libraries(daqd_stream_common PUBLIC daqd_stream_core rt)
target_include_directories(daqd_stream_common PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        )
target_compile_options(daqd_stream_common PRIVATE -fPIC)

install (TARGETS daqd_stream_common
        EXPORT daqd_stream_install
        DESTINATION lib)

add_executable(daqd_stream_common_unit_tests
        tests/test_main.cc
        tests/test_message_queue.cc)
target_link_libraries(daqd_stream_common_unit_tests PRIVATE
        vendor
        daqd_stream_core
        daqd_stream_common
        Threads::Threads
        catch2)

add_test(NAME test_daqd_stream_common_unit_tests
        COMMAND daqd_stream_common_unit_tests
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

=== src/plugins/CMakeLists.txt ===
add_library(daqd_stream_plugins SHARED
        frame_plugin_internal.cc
        sub_frame_plugin.cc
        sub_delay_filter_plugin.cc
        sub_dump_filter_plugin.cc
        sub_plugin_daq_m.cc)
target_link_libraries(daqd_stream_plugins PRIVATE
        daqd_stream_common
        vendor)
target_link_libraries(daqd_stream_plugins PUBLIC
        cds-shmem
        cds::pub_sub
        daqd_stream_core
        Boost::filesystem
        Boost::boost
        ldastools::framecpp)
target_include_directories(daqd_stream_plugins PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/>)
target_include_directories(daqd_stream_plugins PRIVATE
        "${CMAKE_CURRENT_SOURCE_DIR}/private")

install(TARGETS daqd_stream_plugins
        EXPORT daqd_stream_install
        DESTINATION lib)

install(FILES
        include/daqd_stream/plugins/sub_delay_filter_plugin.hh
        include/daqd_stream/plugins/sub_frame_plugin.hh
        include/daqd_stream/plugins/sub_dump_filter_plugin.hh
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/daqd_stream/plugins")

add_library(frame_utils SHARED
        tests/frame_utils.cc)
target_include_directories(frame_utils PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/tests")
target_link_libraries(frame_utils PUBLIC
        daqd_stream_client
        ldastools::framecpp
        Boost::boost
        Boost::filesystem)

add_executable(test_frame_plugin_unittests
        tests/test_main.cc
        tests/create_test_frame.cc
        tests/test_frame_name_parser.cc
        tests/test_find_next_frame.cc)
target_include_directories(test_frame_plugin_unittests PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/private)
target_link_libraries(test_frame_plugin_unittests PRIVATE
        vendor
        frame_utils
        daqd_stream_plugins
        daqd_stream_client
        daqd_stream_common
        catch2)
add_test(NAME "test_frame_plugin_unittests"
        COMMAND test_frame_plugin_unittests
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

add_executable(simple_frame_generator
        tests/simple_frame_generator.cc)
target_include_directories(simple_frame_generator PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/tests")
target_link_libraries(simple_frame_generator PRIVATE
        frame_utils)

=== debian/changelog ===
daqd-stream (0.6.0.x202512162308fe7047ff5b) UNRELEASED; urgency=medium

  * CI Build for testing only

 -- root <root@8dc3e3464af2>  Tue, 16 Dec 2025 23:08:24 +0000

daqd-stream (0.6.0) unstable; urgency=medium

  * Rework of code to split client/server interfaces

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Wed, 04 May 2022 11:16:30 -0700

daqd-stream (0.5.4) unstable; urgency=medium

  * Bug fix, issue #8, second data with a single source was returning gps time
    as the seconds since the begining of the request.  Fix this.

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Fri, 25 Mar 2022 10:18:54 -0700

daqd-stream (0.5.3) unstable; urgency=medium

  * Minor package restructuring to allow building src dir = build dir 

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Mon, 14 Mar 2022 16:52:22 -0700

daqd-stream (0.5.1) unstable; urgency=medium

  * Packaging and misc changes to build on Debian 10 & 11

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Tue, 22 Feb 2022 22:10:53 -0800

daqd-stream (0.5.0) unstable; urgency=medium

  * Initial release of multi input stream support
   * Server can injest multiple input streams
   * Client can view the data as a whole and retreive data in synchronous
     slices across sources.
  * C++ api change, python api remains stable

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Tue, 22 Feb 2022 17:23:20 -0800

daqd-stream (0.4.2) unstable; urgency=medium

  * Added a daqd_server_probe program to help introspect the shared memory
    window

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Fri, 17 Sep 2021 18:15:54 -0700

daqd-stream (0.4.1) unstable; urgency=medium

  * Minor changes to build on both Debian 10 & Debial 11

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Mon, 30 Aug 2021 16:59:52 -0700

daqd-stream (0.4.0) unstable; urgency=medium

  * Incompatible update, moved to variable length buffers for the server.

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Mon, 21 Jun 2021 12:25:04 -0700

daqd-stream (0.3.1) unstable; urgency=medium

  * Bug fix on the python module.  Move where the GIL is released so that the
    system doesn't crash on data retreival.

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Wed, 16 Jun 2021 14:32:07 -0700

daqd-stream (0.3.0) unstable; urgency=medium

  * Removed advligorts-mbuf-dkms requirement from daqd-stream-server.
  * Added a new api call to get the config hash from the client.

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Mon, 14 Jun 2021 15:25:31 -0700

daqd-stream (0.2.0) unstable; urgency=medium

  * Added initial support for reconfiguring the channel list and data plans on
    the fly.

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Fri, 11 Jun 2021 17:12:28 -0700

daqd-stream (0.1.0) unstable; urgency=medium

  * Initial packaging

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Fri, 15 Jan 2021 16:40:46 -0800

=== debian/control ===
Source: daqd-stream
Section: unknown
Priority: optional
Maintainer: Jonathan Hanks <jonathan.hanks@ligo.org>
Build-Depends:
 debhelper (>= 11),
 cmake,
 pkg-config,
 pybind11-dev,
 python3-pybind11,
 python3-numpy,
 python3,
 python3-dev,
 libboost-all-dev,
 libcurl4-gnutls-dev,
 rapidjson-dev,
 libcds-pubsub-dev,
 advligorts-transport-pubsub,
 advligorts-simulated-streams,
 cds-metadata-server,
 python3-requests,
 advligorts-dev,
 libzstd-dev,
 ldas-tools-framecpp-dev,
 libnds2-client-dev,
Standards-Version: 4.5.0
Vcs-Git: https://git.ligo.org/cds/software/daqd_stream
Rules-Requires-Root: no

Package: libdaqd-stream-plugins
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Plugins for the daqd_stream_server

Package: daqd-stream-dev
Architecture: any
Depends:
  build-essential,
  cmake,
  libboost-all-dev,
  libdaqd-stream-plugins,
Description: Development package for the daqd_stream

Package: python3-daqd-stream
Architecture: any
Depends:
 python3,
 python3-numpy,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Python3 bindings for the daqd-stream package.

Package: daqd-stream-server
Architecture: any
Depends:
 libdaqd-stream-plugins,
 ${misc:Depends},
 ${shlibs:Depends},
Description: The daqd-stream-server that merges metadata and channel stream data.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_test:
	ctest

override_dh_auto_test:
	true

## daqd-stream 0.6.0.x202512162309fe7047ff5b

=== debian/changelog ===
daqd-stream (0.6.0.x202512162309fe7047ff5b) UNRELEASED; urgency=medium

  * CI Build for testing only

 -- root <root@d221879524c9>  Tue, 16 Dec 2025 23:09:49 +0000
